#!/usr/bin/python
# -*- coding: UTF-8 -*-


from Tkinter import *
import simpy
import random
import time
from math import copysign
import sys

sys.setrecursionlimit(15000)
Nom_etage = 20
Nom_ascenseur = 3
Nom_plafond = 3
Vitesse = 200

ascenseur_etat = [[1,[],0] for i in range(Nom_ascenseur)]

class ascUI(Frame):
    hauteur = 30
    largeur = 45
    gap = 10
    root = Tk()
    count = 0
    utilisateur = []
    demande = []
    arrive = []
    Execute = 0

    global ascenseur_etat

    def __init__(self,nom_etage,nom_asc,nom_plafond,vitesse):

        self.nom_etage = nom_etage
        self.nom_asc = nom_asc
        self.plafond = nom_plafond
        self.vitesse = vitesse
        self.sousdemande = [[] for i in range(nom_asc)]
        self.sousarrive = [[] for i in range(nom_asc)]
        self.time_dernier = time.time()
        self.etat_asc = [ascenseur_etat[i][0] for i in range(nom_asc)]
        self.label_asc,self.label_attente,self.label_etage,self.asc_position = self.creerblock()
        self.update_asc()
        self.root.mainloop()

    def etg(self,num): #return l'etage selon le chiffre
        return self.nom_etage-num+1

    def sign(self,intn):
        if intn>0:return 1
        if intn<0:return -1
        if intn == 0:return 0

    def autogeneration(self,count):
        ascUI.Execute = count

    def creerblock(self):

        label_attente=[] # counteur d'attent
        label_etage = [] # mark d'etage
        for i in range(self.nom_etage):
            label_attente.append(Label(text='0'))
            label_etage.append(Label(text=i+1)) # plus 1
        label_asc= []
        for i in range(self.nom_asc):
            label_asc.append(Label(text='0'))
        asc_position = [[0 for i in range(self.nom_asc)] for j in range(self.nom_etage)]

        for i in range(0, self.nom_etage + 3):
            for j in range(0, self.nom_asc + 7):
                if i in range(1,self.nom_etage+1): # buttons et counteur
                    if j ==1:
                        label_etage[i-1].grid(row=self.etg(i),column=j) # moins 1
                    if j == 2 and i != self.nom_etage:  # creer les buttons de monte
                        Button(ascUI.root, text='M', command=lambda i=i: self.creerutilisateur(i, 1),
                               bg='white').grid(
                            row=self.etg(i), column=j)
                    if j == 3 and i != 1:  # les buttons de descent
                        Button(ascUI.root, text='D', command=lambda i=i: self.creerutilisateur(i, -1),
                               bg='white').grid(
                            row=self.etg(i), column=j)
                    if j ==4: # counteur de utilisateur d'attente
                        label_attente[i-1].grid(row=self.etg(i),column=j) # moins 1
                if i == 0 or j == 0 or i == self.nom_etage + 2 or j == self.nom_asc + 6 or j == 5: # lieu sans data
                    Frame(ascUI.root, width=ascUI.largeur, height=ascUI.hauteur, bg='grey').grid(row=i, column=j)
                if j in range(1,5) and i ==self.nom_etage+1: #lieu sans data en bas
                    Frame(ascUI.root, width=ascUI.largeur, height=ascUI.hauteur, bg='grey').grid(row=i, column=j)
                if j in range(6,6+self.nom_asc) and i ==self.nom_etage+1: # counteur
                    label_asc[j-6].grid(row=i,column=j)
                if j in range(6,6+self.nom_asc) and i in range(1,1+self.nom_etage):
                    if self.etat_asc[j-6] == self.nom_etage - i+1: #moins 6
                        coleur = 'red'
                    else:
                        coleur = 'yellow' #moin 1 et 6
                    asc_position[i-1][j-6]=Frame(ascUI.root, width=ascUI.largeur, height=ascUI.hauteur, bg=coleur,highlightbackground="black", highlightcolor="black", highlightthickness=1)
                    asc_position[i - 1][j - 6].grid(row=i, column=j)
        Button(self.root,text='auto',command=lambda :self.autogeneration(1),bg='white').grid(row=self.nom_etage+1,column=1,columnspan=2)
        Button(self.root,text='arret',command=lambda :self.autogeneration(0),bg='white').grid(row=self.nom_etage+1,column=3,columnspan=2)
        return label_asc,label_attente,label_etage,asc_position

    def modifier(self,label_asc,label_attente,label_etage,asc_position):
            for i in range(len(label_attente)):
                count =0
                for j in range(len(self.sousdemande)):
                    count = count + self.sousdemande[j].count(i+1)+self.sousdemande[j].count(-(i+1))
                label_attente[i]['text']=count
            for i in range(len(label_asc)):
                label_asc[i]['text']=len(ascenseur_etat[i][1])
            for i in range(0, self.nom_etage + 3):
                for j in range(0, self.nom_asc + 7):
                    if j in range(6,6+self.nom_asc) and i in range(1,1+self.nom_etage):
                        if self.etat_asc[j-6] == self.nom_etage - i+1: #moins 6
                            coleur = 'red'
                        else:
                            coleur = 'yellow'
                        asc_position[i-1][j-6].configure(bg=coleur)
            return label_asc, label_attente, label_etage, asc_position

    def update_asc(self):
        self.etat_asc = [ascenseur_etat[i][0] for i in range(self.nom_asc)]
        self.transport()
        if ascUI.Execute == 1:
            if time.time() - self.time_dernier >2:
                self.time_dernier = time.time()
                self.creerutilisateur(random.randint(1,self.nom_etage),random.sample([-1,1],1))
        self.label_asc, self.label_attente, self.label_etage, self.asc_position=self.modifier(self.label_asc,self.label_attente,self.label_etage,self.asc_position)
        self.root.update_idletasks()
        self.root.update()
        self.root.after(self.vitesse, self.update_asc)

    def creerutilisateur(self,etage,updown):

        dep = etage
        if updown == 1:
            arri = random.randint(etage+1,self.nom_etage)
        else:
            arri = random.randint(1,etage)
        ascUI.count += 1
        ascUI.utilisateur.append([ascUI.count, dep, arri, 0])

        if dep > arri:
            ascUI.demande.append(-dep)
        else:
            ascUI.demande.append(dep)  # ajoute le demande
        ascUI.arrive.append(arri)

    def transport(self):
        demande = ascUI.demande
        sousdemande = self.sousdemande
        sousarrive = self.sousarrive
        arrive = ascUI.arrive
        nom_ascenseur = self.nom_asc
        nom_etage = self.nom_etage
        plafond = self.plafond
        count = [nom_etage for i in range(nom_etage)]

        if demande != []:
            for j in range(len(demande)):
                for i in range(nom_ascenseur):  # change l'etat d'ascenseur nul selon demande
                    if -ascenseur_etat[i][2] != self.sign(demande[0]):
                        count[i] = abs(ascenseur_etat[i][0] - abs(demande[0]))
                if min(count) < nom_etage:
                    dist = count.index(min(count))
                    if ascenseur_etat[i][1] != plafond:
                        sousdemande[dist].append(demande[0])
                        sousarrive[dist].append(arrive[0])
                        del demande[0]
                        del arrive[0]

        for i in range(nom_ascenseur):  # change l'etat d'ascenseur nul selon demande
            if sousdemande[i] != []:
                if ascenseur_etat[i][0] > abs(sousdemande[i][0]) and ascenseur_etat[i][1]==[] :
                    ascenseur_etat[i][2] = -1
                elif ascenseur_etat[i][0] < abs(sousdemande[i][0]) and ascenseur_etat[i][1]==[]:
                    ascenseur_etat[i][2] = 1

        for i in range(0, nom_ascenseur):  # movement de un pas d'ascenseur
            if ascenseur_etat[i][2] == 1 and ascenseur_etat[i][0] < nom_etage:
                ascenseur_etat[i][0] += 1
            elif ascenseur_etat[i][2] == -1 and ascenseur_etat[i][0] > 1:
                ascenseur_etat[i][0] -= 1
            elif ascenseur_etat[i][0] == 1 or ascenseur_etat[i][0] == nom_etage:
                ascenseur_etat[i][2] = -ascenseur_etat[i][2]
        for i in range(0, nom_ascenseur):
            while ascenseur_etat[i][0] in ascenseur_etat[i][1]:  # arrive d'utilisateur
                ascenseur_etat[i][1].remove(ascenseur_etat[i][0])

            while ascenseur_etat[i][1] == [] and -ascenseur_etat[i][0] * ascenseur_etat[i][2] in sousdemande[i]:  # Reussite un utilisateur dans un ascenseur nul
                index = sousdemande[i].index(-ascenseur_etat[i][0] * ascenseur_etat[i][2])
                ascenseur_etat[i][1].append(sousarrive[i][index])
                del sousarrive[i][index]
                del sousdemande[i][index]
                ascenseur_etat[i][2] = -ascenseur_etat[i][2]

            while ascenseur_etat[i][0] * ascenseur_etat[i][2] in sousdemande[i]:  # Reussite un utilisateur
                if len(ascenseur_etat[i][1]) < plafond:
                    index = sousdemande[i].index(ascenseur_etat[i][0] * ascenseur_etat[i][2])
                    ascenseur_etat[i][1].append(sousarrive[i][index])
                    del sousarrive[i][index]
                    del sousdemande[i][index]
                else:break
            if ascenseur_etat[i][2]==0:
                if ascenseur_etat[i][0] in sousdemande[i]:
                    index = sousdemande[i].index(ascenseur_etat[i][0])
                    ascenseur_etat[i][1].append(sousarrive[i][index])
                    del sousarrive[i][index]
                    del sousdemande[i][index]
                    ascenseur_etat[i][2] = 1  # monte
                if -ascenseur_etat[i][0] in sousdemande[i]:
                    index = sousdemande[i].index(-ascenseur_etat[i][0])
                    ascenseur_etat[i][1].append(sousarrive[i][index])
                    del sousarrive[i][index]
                    del sousdemande[i][index]
                    ascenseur_etat[i][2] = -1  # monte
        for i in range(0, nom_ascenseur):
            if ascenseur_etat[i][1] == []:  # aucun de demande
                if sousdemande[i] == []:
                    ascenseur_etat[i][2] = 0
                delta = bool
                for j in range(len(sousdemande[i])):
                    if ascenseur_etat[i][0] * ascenseur_etat[i][2] > ascenseur_etat[i][2] * abs(sousdemande[i][j]):
                        delta = True
                    # aucun de demande dans l'etage a la direction d'ascenseur actuel
                    else:
                        delta = False
                        break
                if delta: ascenseur_etat[i][2] = 0


ascUI(Nom_etage,Nom_ascenseur,Nom_plafond,Vitesse)

